/*
 * JBoss, Home of Professional Open Source
 * Copyright 2013, Red Hat, Inc. and/or its affiliates, and individual
 * contributors by the @authors tag. See the copyright.txt in the
 * distribution for a full listing of individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jboss.jdgtests;

import java.io.IOException;
import java.io.PrintWriter;

import javax.inject.Inject;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.infinispan.manager.DefaultCacheManager;

/**
 * 
 * @author John Osborne
 * 
 */
@SuppressWarnings("serial")
@WebServlet("/jdbc")
public class LoadRecordsJDBCServlet extends HttpServlet {

    static String PAGE_HEADER = "<html><head><title>Load Records from JDBC</title></head><body>";
    static String PAGE_FOOTER = "</body></html>";

    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        
    	resp.setContentType("text/html");
        PrintWriter writer = resp.getWriter();
        writer.println(PAGE_HEADER);
        
        writer.println("<form action=\"\" method=\"post\" >");
        writer.println("Enter the number of entries to traverse via JDBC:<br/>");
        writer.println("<input id=\"numEntries\" type=\"text\" name=\"numEntries\"><br/>");
        writer.println("</form>");
        
        writer.println(PAGE_FOOTER);
        writer.close();
    }
    
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse resp) throws ServletException, IOException {
        
    	int numEntries = Integer.parseInt(request.getParameter("numEntries"));
    	
        resp.setContentType("text/html");
        PrintWriter writer = resp.getWriter();
        writer.println(PAGE_HEADER);
        
        boolean success = Node.getInstance().traverseJDBCResultSet("tin",numEntries);
        
        if(success)
        	writer.println("Success!</br>");
        else
        	writer.println("Failure!</br>");
        
        writer.println(PAGE_FOOTER);
        writer.close();
    }


}
