/*
 * JBoss, Home of Professional Open Source
 * Copyright 2013, Red Hat, Inc. and/or its affiliates, and individual
 * contributors by the @authors tag. See the copyright.txt in the
 * distribution for a full listing of individual contributors.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 * http://www.apache.org/licenses/LICENSE-2.0
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jboss.jdgtests;

import java.io.IOException;
import java.io.PrintWriter;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * 
 * @author John Osborne
 * 
 */
@SuppressWarnings("serial")
@WebServlet("/embedded")
public class NodeServlet extends HttpServlet {

    static String PAGE_HEADER = "<html><head><title>Traverse Embedded Cache Node 1</title></head><body>";
    static String PAGE_FOOTER = "</body></html>";
    
    public void init() throws ServletException {
        
    	try{
    		Node.getInstance();
    	}catch(IOException e){
    		
    	}
    	        
    }


    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp) throws ServletException, IOException {
        
    	resp.setContentType("text/html");
        PrintWriter writer = resp.getWriter();
        writer.println(PAGE_HEADER);
        
        writer.println("<form action=\"\" method=\"post\" >");
        writer.println("Enter the number of entries to traverse via the Embedded Cache:<br/>");
        writer.println("<input id=\"numEntries\" type=\"text\" name=\"numEntries\"><br/>");
        writer.println("<input id=\"getEntrySet\" type=\"checkbox\" name=\"getEntrySet\">getEntrySet<br/>");
        writer.println("<input type=\"submit\" value=\"Ready Set Go!!!\"/><br/>");
        writer.println("</form>");

        writer.println(PAGE_FOOTER);
        writer.close();
    }
    
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse resp) throws ServletException, IOException {
        
    	resp.setContentType("text/html");
        PrintWriter writer = resp.getWriter();
        writer.println(PAGE_HEADER);
        
        int numEntries = Integer.parseInt(request.getParameter("numEntries"));
    	//boolean getEntrySet = Boolean.parseBoolean(request.getParameter("getEntrySet"));
    	String checkboxes[] = request.getParameterValues("getEntrySet");
    	int count = 0;
    	
    	if(checkboxes != null && checkboxes[0] != null){
    		
    		if(checkboxes[0].equals("on"))
            	count = Node.getInstance().traverseEntrySet();
            
            else
            	count = Node.getInstance().traverseEmbeddedCache(numEntries);
            
    	}else
    		count = Node.getInstance().traverseEmbeddedCache(numEntries);
    	
        
        writer.println("Successfully found " + count + " records!!!</br>");
        
        writer.println(PAGE_FOOTER);
        writer.close();
        
    }

}
