package org.jboss.jdgtests;

import java.util.concurrent.atomic.AtomicInteger;
import java.util.logging.Logger;

import org.infinispan.Cache;

public class jdgGetThread implements Runnable {

	final static Logger logger = Logger.getLogger(jdgGetThread.class.getName());
	
	public static AtomicInteger threadsCompleted = new AtomicInteger();
	AtomicInteger atomicMisses = new AtomicInteger();
	int threadNumber = 0;
	int numThreads = 0;
	int numEntries = 0;
	public static long startTime = 0;
	
	final Cache<String, Object> cache;
	
	public jdgGetThread(int threadNumber, int numThreads, int numEntries, Cache<String, Object> cache) {
	       this.threadNumber=threadNumber;
	       this.numThreads=numThreads;
	       this.numEntries=numEntries;
	       this.cache = cache;
	}
	
	@Override
	public void run() {
		
		logger.info("Kickoff new thread number: " + this.threadNumber);
		
		for(int i=1+threadNumber; i<=numEntries; i+=numThreads){
		       
			if(cache.get(Integer.toString(i)) == null)
				atomicMisses.incrementAndGet();
			
	    }
		
		//if(atomicMisses.intValue() > 0)
		logger.info("This thread found " + atomicMisses.toString() + " misses!!!");
		//logger.info("This thread is done: totalMisses="+atomicMisses.toString()+" count="+atomicCount.toString());
		threadsCompleted.incrementAndGet();
		
		if(threadsCompleted.intValue() >= this.numThreads){
			long endTime = System.nanoTime(); 
			logger.info("traverseEmbeddedCache took " + ((endTime - startTime) / 1000000) + " milliseconds to execute");
			threadsCompleted.set(0);
		}
		
	}
}
